/*****************************************************************
 *  Author: Pere Urb�n Bayes
 *  e-mail: purbon@ccd.uab.es
 *  Description :  Header file used to define constant values and
 *                 some structure of code.
 *  Last Changes  : 10-06-2005
 *****************************************************************/

#ifndef _CONSTANTS_H_
#define _CONSTANTS_H_

#include "getopt.h" 

/* Binary type definition */
typedef  enum { false, true } Boolean;

/* Code Word type dinition */
typedef unsigned int small_codeWord;
typedef unsigned int *large_codeWord;
 
/* Code Word state. */
#define KERNEL_ELEMENT 0
#define NOT_PROCESSED -1
#define LEADER -2

/* Minim working variable length. In our case this is the Usigned int value. */
#define UnsignedIntLength sizeof(small_codeWord) << 3

/* Binary Search constants. */
#define NOT_FOUND -1

/* Comparation constants */
#define BIGGER 1
#define SMOLLER -1
#define EQUAL 0

/* Memory error constants. */
#define MEM_ERROR 0

/* File where the application will put the results. */
#define OUTPUT_EXTENSION ".out.txt"

/* Correctnes of the main function return value. */
#define NOT_OK 0
#define OK 1

/* Update LiderSet constants values. */
#define EMPTY_ELEMENT -1

/*Path divide simbol selection. */

#define _LINUX_

#ifdef _WIN_
 #define DIV_PATH "\\"
#else 
 #define DIV_PATH "/"
#endif

/* Structures of data used to represent and work with the code.*/

/* Smaller codes. */
typedef struct small_wCodeWord
{
 small_codeWord  codeWord;
 int weight;
 int state;
 } small_wCodeWord;

/* Large codes. */

typedef struct large_wCodeWord
{
 large_codeWord codeWord;
 int weight;
 int state;
} large_wCodeWord;

/* Global module variables and structures. */

/* The path to the data code file.*/
char * filePath;

/* Boolean variable indicating that the imput is binary*/
Boolean binaryInput;

/* The number of blocs present present on our files. */
int limbs;

/*Code base element.*/
int base;

#endif
